mod Maux

incl Mtex

incl Mtexpl

rem 
  \para \bf  Propositional Logic.  \end 

rem 
  \para \it  Arithmetization of propositional formulas.  \end 

fun/0 Tc 'Tex_f0_pl_tc'
  Tc = 0,0

fun/0 Fc 'Tex_f0_pl_fc'
  Fc = 1,0

fun Pvar 'Tex_f1_pl_pvar'
  Pvar(i) = 2,i

fun Not 'Tex_f1_pl_not'
  Not(a) = 3,a

fun/2 And 'Tex_f2_pl_and'
  And(a,b) = 4,a,b

fun/2 Or 'Tex_f2_pl_or'
  Or(a,b) = 5,a,b

fun/2 Imp 'Tex_f2_pl_imp'
  Imp(a,b) = 6,a,b

fun/2 Iff 'Tex_f2_pl_iff'
  Iff(a,b) = 7,a,b

pred Form 
  Form(Tc)
  Form(Fc)
  Form Pvar(i) <- N(i)
  Form Not(a) <- Form(a)
  Form And(a,b) <- Form(a) & Form(b)
  Form Or(a,b) <- Form(a) & Form(b)
  Form Imp(a,b) <- Form(a) & Form(b)
  Form Iff(a,b) <- Form(a) & Form(b)

pred Lform 
  Lform(0)
  Lform(a,as) <- Form(a) & Lform(as)

rem 
  \para \it  Truth predicate.  \end 

pred/2 True 'Tex_p2_pl_true'
  True(v,Tc)
  True(v,Pvar(i)) <- i in v
  True(v,Not(a)) <- ~True(v,a)
  True(v,And(a,b)) <- True(v,a) & True(v,b)
  True(v,Or(a,b)) <- True(v,a)
  True(v,Or(a,b)) <- ~True(v,a) & True(v,b)
  True(v,Imp(a,b)) <- ~True(v,a)
  True(v,Imp(a,b)) <- True(v,a) & True(v,b)
  True(v,Iff(a,b)) <- True(v,a) & True(v,b)
  True(v,Iff(a,b)) <- ~True(v,a) & ~True(v,b)

rem 
  \para \it  Tautologies.  \end 

pred Taut 'Tex_p1_pl_taut'
  Taut(a) <-> \a vTrue(v,a)

